/*	This file is part of Advantech VCOM Linux.
 *
 *	Copyright (c) 2009 - 2021 ADVANTECH CORPORATION.  All rights reserved. 
 *
 *	Advantech VCOM Linux is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation, either version 3 of the License, or
 *	(at your option) any later version.
 *
 *	Advantech VCOM Linux  is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with Advantech VCOM Linux.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <dirent.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "advconf.h"
#include "proc_tools.h"

int main(int argc, char *argv[])
{
	int i;
	pid_t pid;
	char ifname[1024];
	char cmd[1024];
	int cmdlen;
	struct stat sb;	
		
	for(i = 0; i < VCOM_PORTS; i++){
		char * type;
		char * port;
		char * ip;
		char * rip;
		char * ssl;

		type = port = ip = rip = ssl = 0;

		snprintf(ifname, sizeof(ifname), "/proc/vcom/advproc%d", i);

		if(stat(ifname, &sb)){
			printf("cannot access VCOM interface %s\n", ifname);
			continue;
		}

		if(__cmd_inode_search_pid("vcomd", sb.st_ino, 
					cmd, sizeof(cmd), &cmdlen, 
					&pid)){
			continue;
		}
		
		type = __cmd_get_opts(cmd, cmdlen, "-d");
		port = __cmd_get_opts(cmd, cmdlen, "-p");
		ip = __cmd_get_opts(cmd, cmdlen, "-a");
		ssl = __cmd_get_opts(cmd, cmdlen, "-S");
		rip = __cmd_get_opts(cmd, cmdlen, "-r");

		printf("ttyADV%d PID:%ld %s Dev:%s Port%s IP:%s%s%s\n",
			 i, (long)pid, (ssl)?"TLS":"TCP",type, port, 
			ip, rip?"|":"", rip?rip:"");
	}

	return 0;

}
